package de.ruben.opencms.modules.ftpd;

import java.util.Iterator;
import java.util.Map;
import java.util.Properties;

import org.opencms.configuration.CmsConfigurationManager;
import org.opencms.db.CmsPublishList;
import org.opencms.file.CmsObject;
import org.opencms.main.CmsEvent;
import org.opencms.module.A_CmsModuleAction;
import org.opencms.module.CmsModule;
import org.opencms.report.I_CmsReport;

import de.ruben.opencms.modules.ftpd.ParseException;
import de.ruben.opencms.modules.ftpd.Server;

/*
 * this class handles the opencms module lifecycle hooks
 * 
 * author ruben malchow (ruben@khm.de), see http://disco.kalkatraz.de/opencmsftpd
 * for details. 
 * 
 */

public class FtpdAction extends A_CmsModuleAction {

	private static Server s;

	public FtpdAction() {
		System.err.println("FtpdAction.<init> : OpenCMS FTPD Module Action instantiated ... ");
		try {
			s=new Server();
		} catch (ParseException e) {
			e.printStackTrace();
		}
	}

	private Server getServer() {
		return s;
	}
	
	public void initialize(CmsObject arg0, CmsConfigurationManager arg1, CmsModule arg2) {
		try {
			System.err.println("OpenCMS FTPD Module Action --> initialize");
			int port=21;
			try {
				port=Integer.parseInt(arg2.getParameter("port"));
			} catch (Exception e) {
			}
			
			Properties p=new Properties();
			
			Map m=arg2.getParameters();
			System.err.println("OpenCMS FTPD Module Action --------------------------------------> ");
			for (Iterator iter=m.keySet().iterator();iter.hasNext();) {
				String s=(String)iter.next();
				System.err.println("OpenCMS FTPD Module Action --> "+s+" = "+arg2.getParameter(s));
				p.put(s,arg2.getParameter(s));
			}
			System.err.println("OpenCMS FTPD Module Action --------------------------------------> ");
			
			if(s!=null) {
				System.err.println("OpenCMS FTPD Module Action --> stopping current server instance ... ");
				try {
					s.stopServer();
				} catch (Exception e) {
				}
			}
			try {
				System.err.println("OpenCMS FTPD Module Action --> creating new server instance ... ");
				s=new Server(p,port);
			} catch (ParseException e) {
				e.printStackTrace();
			}
			try {
				System.err.println("OpenCMS FTPD Module Action --> starting new server instance ... ");
				s.startServer();
			} catch (Exception e) {
				e.printStackTrace();
			}
			System.err.println("OpenCMS FTPD Module Action --> done ?");
		} catch (Exception e) {
			System.err.println("de.ruben.opencms.modules.ftpd.FtpdAction.initialize() : ###########################################################");
			System.err.println("de.ruben.opencms.modules.ftpd.FtpdAction.initialize() : #  ");
			System.err.println("de.ruben.opencms.modules.ftpd.FtpdAction.initialize() : #  ERROR ");
			System.err.println("de.ruben.opencms.modules.ftpd.FtpdAction.initialize() : #  ");
			System.err.println("de.ruben.opencms.modules.ftpd.FtpdAction.initialize() : ###########################################################");
			System.err.println("de.ruben.opencms.modules.ftpd.FtpdAction.initialize() : #  ");
			e.printStackTrace();
			System.err.println("de.ruben.opencms.modules.ftpd.FtpdAction.initialize() : #  ");
			System.err.println("de.ruben.opencms.modules.ftpd.FtpdAction.initialize() : ###########################################################");
		} catch (Throwable t) {
			System.err.println("de.ruben.opencms.modules.ftpd.FtpdAction.initialize() : ###########################################################");
			System.err.println("de.ruben.opencms.modules.ftpd.FtpdAction.initialize() : #  ");
			System.err.println("de.ruben.opencms.modules.ftpd.FtpdAction.initialize() : #  ERROR ");
			System.err.println("de.ruben.opencms.modules.ftpd.FtpdAction.initialize() : #  ");
			System.err.println("de.ruben.opencms.modules.ftpd.FtpdAction.initialize() : ###########################################################");
			System.err.println("de.ruben.opencms.modules.ftpd.FtpdAction.initialize() : #  ");
			t.printStackTrace();
			System.err.println("de.ruben.opencms.modules.ftpd.FtpdAction.initialize() : #  ");
			System.err.println("de.ruben.opencms.modules.ftpd.FtpdAction.initialize() : ###########################################################");
		}
	}

	public void moduleUninstall(CmsModule arg0) {
		System.err.println("OpenCMS FTPD Module Action --> moduleUninstall");
		getServer().stopServer();
	}

	public void moduleUpdate(CmsModule arg0) {
		System.err.println("OpenCMS FTPD Module Action --> moduleUpdate");
		initialize(null,null,arg0);
	}

	public void publishProject(CmsObject arg0, CmsPublishList arg1, int arg2, I_CmsReport arg3) {
		System.err.println("OpenCMS FTPD Module Action --> publishProject");
	}

	public void shutDown(CmsModule arg0) {
		System.err.println("OpenCMS FTPD Module Action --> shutDown");
		getServer().stopServer();
	}

	public void cmsEvent(CmsEvent arg0) {
		System.err.println("OpenCMS FTPD Module Action --> cmsEvent");
	}


}
