package de.ruben.opencms.modules.ftpd;

/**
 * 
 * taken from ryan heise's jftpd package: 
 * 	
 * 	http://www.progsoc.uts.edu.au/~rheise/projects/jftpd/
 * 
 * modified by ruben malchow :
 * 
 * 	http://disco.kalkatraz.de/opencmsftpd
 * 
 */

public class ParseException extends Exception {

	public static final int PROPERTY_UNDEFINED = 0;
	public static final int PROPERTY_INVALID = 1;
	private int reason;
	private String propertyName;

	private String propertyValue;

	public ParseException(int reason, String propertyName, String propertyValue) {
		this.reason = reason;
		this.propertyName = propertyName;
		this.propertyValue = propertyValue;
	}

	public int getReason() {
		return reason;
	}

	public String getPropertyName() {
		return propertyName;
	}


	public String getPropertyValue() {
		return propertyValue;
	}

	public String getMessage() {
		switch (reason) {
		case PROPERTY_UNDEFINED:
			return "Property '" + propertyName + "' is undefined.";
		case PROPERTY_INVALID:
			return "Property '" + propertyName + "' is invalid: " + propertyValue;
		default:
			return "Unknown reason.";
		}
	}
}
