package de.ruben.opencms.modules.ftpd;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.util.Hashtable;

import de.ruben.opencms.modules.ftpd.AsciiRepresentation;
import de.ruben.opencms.modules.ftpd.ImageRepresentation;

/**
 * 
 * taken from ryan heise's jftpd package: 
 * 	
 * 	http://www.progsoc.uts.edu.au/~rheise/projects/jftpd/
 * 
 * modified by ruben malchow :
 * 
 * 	http://disco.kalkatraz.de/opencmsftpd
 * 
 */

public abstract class Representation {

	private static Hashtable representations = new Hashtable();
	public static final Representation ASCII = new AsciiRepresentation();
	public static final Representation IMAGE = new ImageRepresentation();

	public static Representation get(char code) {
		return (Representation) representations.get(new Character(code));
	}

	private String name;

	private char code;

	protected Representation(String name, char code) {
		this.name = name;
		this.code = code;

		representations.put(new Character(code), this);
	}

	public final String getName() {
		return name;
	}

	public final char getCode() {
		return code;
	}

	public abstract InputStream getInputStream(Socket socket)
			throws IOException;

	public abstract OutputStream getOutputStream(Socket socket)
			throws IOException;

	public abstract long sizeOf(File file) throws IOException;
}
